from Achievement import Achievement
from odict import odict

loadedInProgressSqlite = {}
loadedInProgressPickle = {}

# == ACHIEVEMENTGROUP CLASS =============================
class AchievementGroup:
    __id = None
    __name = None
    __description = None
    __achievements = None
  
    def __init__(self, newID, newName, newDescription):
        self.__id = newID
        self.__name = newName
        self.__description = newDescription
        self.__achievements = odict()
    
    def __getattr__(self, name):
        if name == "id":
            return self.__id
        elif name == "name":
            return self.__name
        elif name == "description":
            return self.__description
        elif name == "achievements":
            return self.__achievements
        elif name in self.__dict__.keys():
            return self.__dict__[name]
        else:
            raise AttributeError, name
    
    def __setattr__(self, name, value):
        if name == "id":
            self.__id = value
        elif name == "name":
            self.__name = value
        elif name == "description":
            self.__description = value
        elif name != "achievements":
            self.__dict__[name] = value
    
    def __getitem__(self, name):
        if name in self.__achievements.keys():
            return self.__achievements[name]
        else:
            return None
    
    def __setitem__(self, name, value):
        global loadedInProgressSqlite
        global loadedInProgressPickle
        if type(value) is tuple:
            if not name in self.__achievements.keys():
                if self.__id in loadedInProgressPickle.keys() and name in loadedInProgressPickle[self.__id].__achievements.keys():
                    self.__achievements[name] = loadedInProgressPickle[self.__id].__achievements[name]
                    del loadedInProgressPickle[self.__id][name]
                else:
                    if value[-1] == value[1]:
                        self.__achievements[name] = Achievement(self.__id, name, value[0], value[1])
                    else:
                        self.__achievements[name] = Achievement(self.__id, name, value[0], value[1], value[2])
        else:
            self.__achievements[name] = value
        
        if self.__id in loadedInProgressSqlite.keys() and name in loadedInProgressSqlite[self.__id].keys():
            for steamID in loadedInProgressSqlite[self.__id][name]:
                self.__achievements[name].setProgressForPlayer(steamID, loadedInProgressSqlite[self.__id][name][steamID])
            del loadedInProgressSqlite[self.__id][name]
    
    def __delitem__(self, key):
        if key in self.__achievements.keys():
            del self.__achievements[key]
   
    def getAchievements(self):
        return self.__achievements
# =======================================================